
#define UNICODE
#define _UNICODE
#include <windows.h>

#include <tchar.h>
#include "errorlogger.h"



/*
 * LogErr
 *	A (hopefully) simplified interface to reporting errors to the Windows
 * Event Viewer.  Since this is the last resort in error reporting, if an
 * error occurs, LogErr() simply returns!
 *
 * DWORD err - The error returned from GetLastError(), WSAGetLastError(), etc.
 * LPTSTR lpSource - Where the error originated, typically this is the name
 *	of the service or application.
 * LPTSTR lpDescription - Any extra info to report with the error.  Can be NULL.
 */
VOID LogErr(
	DWORD	err,
	LPTSTR	lpSource,
	LPTSTR	lpDescription )
{
	HANDLE	hEventLog;
	LPCTSTR	strings[ 1 ];

	strings[ 0 ] = lpDescription;

	hEventLog = RegisterEventSource( NULL, lpSource );

	if ( !ReportEvent( hEventLog, EVENTLOG_INFORMATION_TYPE, (WORD)1, (DWORD)1,
		NULL, 1, 0, strings, NULL ) ) {
		//oops, oh no! Panic!
	}


	DeregisterEventSource( hEventLog );
	
//	Do something cool();

}

